﻿using System;
using System.Globalization;

namespace SpiceLogic.WinHTMLEditor.WPFSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow
    {
        private readonly WinForm.WinFormHtmlEditor formHTMLEditor;

        public MainWindow()
        {
            InitializeComponent();
            formHTMLEditor = (WinForm.WinFormHtmlEditor) this.FindResource("formHTMLEditor");
        }

        private void WinFormHtmlEditor_HtmlChanged(object sender, EventArgs e)
        {
            if (this.formHTMLEditor == null)
                return;
            lblStatus.Content = "The length of BodyHTML = " + this.formHTMLEditor.BodyHtml.Length.ToString(CultureInfo.InvariantCulture);
        }

        private void Window_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            this.formHTMLEditor.ToolbarItemOverrider.ToolbarItems.FontName.Focus();
            this.formHTMLEditor.ToolbarItemOverrider.ToolbarItems.FontSize.Focus();
            this.formHTMLEditor.ToolbarItemOverrider.ToolbarItems.TitleInsert.Focus();

            this.formHTMLEditor.Focus();           
        }

        private void btnBodyHtmlSetter_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            this.formHTMLEditor.BodyHtml = "Hi Everyone, the time is now : " + DateTime.Now;
        }
    }
}