﻿using System;
using System.Windows.Forms;
using SpiceLogic.HtmlEditorControl.Domain.BOs;
using SpiceLogic.HtmlEditorControl.Domain.BOs.EditorEventArgs;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the ContextMenuShowing event of the winFormHtmlEditor1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="SpiceLogic.HtmlEditorControl.Domain.BOs.EditorEventArgs.ContextMenuShowingEventArgs"/> instance containing the event data.</param>
        private void winFormHtmlEditor1_ContextMenuShowing(object sender, ContextMenuShowingEventArgs e)
        {
            contextMenuItem_delete.Enabled = winFormHtmlEditor1.StateQuery.CanDelete();
            contextMenuItem_copy.Enabled = winFormHtmlEditor1.StateQuery.CanCopy();
            contextMenuItem_cut.Enabled = winFormHtmlEditor1.StateQuery.CanCut();
            contextMenuItem_paste.Enabled = winFormHtmlEditor1.StateQuery.CanPaste();
            
            youTubeVideoPropertiesToolStripMenuItem.Visible = winFormHtmlEditor1.StateQuery.IsYouTubeVideo();

            contextMenuItem_imageProperties.Visible = winFormHtmlEditor1.StateQuery.IsImage();
            contextMenuItem_linkProperties.Visible = winFormHtmlEditor1.StateQuery.IsHyperLink();

            mergeCellsToolStripMenuItem.Enabled = winFormHtmlEditor1.StateQuery.CanMergeTableCells();
            contextMenuItem_tableProperties.Visible = winFormHtmlEditor1.StateQuery.IsTable() || winFormHtmlEditor1.StateQuery.IsTableCell();
            contextMenuItem_cellProperties.Visible = winFormHtmlEditor1.StateQuery.IsTableCell();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_delete control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_delete_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Editor.Delete();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_paste control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_paste_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Editor.Paste();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_copy control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_copy_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Editor.Copy();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_cut control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_cut_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Editor.Cut();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_imageProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_imageProperties_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.ToolbarItemOverrider.OnImageButtonClicked(sender, e);
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_linkProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_linkProperties_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.ToolbarItemOverrider.OnHyperLinkButtonClicked(sender, e);
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_cellProperties control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_cellProperties_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.ToolbarItemOverrider.OnTableCellEditingClicked(sender, e);
        }

        /// <summary>
        /// Handles the Click event of the tablePropertiesToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void tablePropertiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.ToolbarItemOverrider.OnTableModifyButtonClicked(sender, e);
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_align_left control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_align_left_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Formatting.AlignLeft();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_align_center control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_align_center_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Formatting.AlignCenter();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_align_right control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_align_right_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Formatting.AlignRight();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_align_remove control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_align_remove_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Formatting.RemoveAlignment();
        }

        /// <summary>
        /// Handles the Click event of the contextMenuItem_selectAll control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void contextMenuItem_selectAll_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Selection.SelectAll();
        }

        /// <summary>
        /// Handles the Click event of the insertRowBeforeToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="EventArgs" /> instance containing the event data.</param>
        private void insertRowBeforeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.InsertRow(InsertPositions.Before);
        }

        /// <summary>
        /// Handles the Click event of the insertRowAfterToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="EventArgs" /> instance containing the event data.</param>
        private void insertRowAfterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.InsertRow(InsertPositions.After);
        }

        /// <summary>
        /// Handles the Click event of the deleteRowToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void deleteRowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.DeleteRow();
        }

        /// <summary>
        /// Handles the Click event of the insertColumnBeforeToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="EventArgs" /> instance containing the event data.</param>
        private void insertColumnBeforeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.InsertColumn(InsertPositions.Before);
        }

        /// <summary>
        /// Handles the Click event of the insertColumnAfterToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="EventArgs" /> instance containing the event data.</param>
        private void insertColumnAfterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.InsertColumn(InsertPositions.After);
        }


        /// <summary>
        /// Handles the Click event of the deleteColumnToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void deleteColumnToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.DeleteColumn();
        }

        /// <summary>
        /// Handles the Click event of the mergeCellsToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="EventArgs" /> instance containing the event data.</param>
        private void mergeCellsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.Content.TableAuthoringService.MergeSelectedCells();
        }

        /// <summary>
        /// Handles the Click event of the youTubeVideoPropertiesToolStripMenuItem control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void youTubeVideoPropertiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            winFormHtmlEditor1.ToolbarItemOverrider.OnYouTubeVideoInsertButtonClicked(sender, e);
        }
    }
}
