﻿Imports System.Collections.Generic
Imports System.Windows.Forms
Imports System.Xml.Serialization
Imports System.IO

''' <summary>
''' This class demonstrates the usage of .NET Win HTML Editor Control.
''' </summary>
''' <remarks></remarks>
Public Class Form1

    ''' <summary>
    ''' This list holds the deserialized student data form the XML file. Finally this list will be
    ''' bound to the BindingSource.
    ''' </summary>
    ''' <remarks></remarks>
    Private myStudents As New List(Of Student)()

    ''' <summary>
    ''' The xml file where the student data is stored.
    ''' </summary>
    ''' <remarks></remarks>
    ReadOnly studentXmlFile As String = String.Format("{0}\students.xml", Application.StartupPath)


    ''' <summary>
    ''' When the form is loaded, the student data is deserialized and myStudent field is populated.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As EventArgs) Handles MyBase.Load
        If File.Exists(studentXmlFile) Then
            Try
                Dim xs As New XmlSerializer(GetType(List(Of Student)))
                Using s As Stream = File.OpenRead(studentXmlFile)
                    myStudents = DirectCast(xs.Deserialize(s), List(Of Student))
                End Using
            Catch
            End Try
        End If

        BindingSource1.DataSource = myStudents

    End Sub

    ''' <summary>
    ''' This method serialize the student data in an XML file.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SaveToolStripButton_Click(ByVal sender As System.Object, ByVal e As EventArgs) Handles SaveToolStripButton.Click
        Validate()
        BindingSource1.EndEdit()
        Dim xs As New XmlSerializer(GetType(List(Of Student)))
        Using s As Stream = File.Create(studentXmlFile)
            xs.Serialize(s, myStudents)
        End Using
    End Sub
End Class
