﻿
' ***********************************************************************
' Assembly         : WinFormHtmlEditor
' Author           : SpiceLogic
' Created          : 12-15-2012
'
' Last Modified By : SpiceLogic

' ***********************************************************************
' <copyright file="ucLists.cs" company="SpiceLogic Inc.">
'     Copyright (c) SpiceLogic Inc.. All rights reserved.
' </copyright>
' <summary></summary>
' ***********************************************************************

Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Windows.Forms
Imports Dialog_Customization.Dialogs.StyleBuilder

Namespace Dialog_Customization.Dialogs.StyleBuilder
    ''' <summary>
    ''' Class ucLists
    ''' </summary>
    <ToolboxItem(False)> _
    <FormSelectorPage("List Position", "list-style-position")> _
    Partial Public Class ucListPosition
        Inherits UserControl
        Implements IEditorStylePage
        ''' <summary>
        ''' The _dict
        ''' </summary>
        ReadOnly _dict As Dictionary(Of String, String)

#Region "Preset of possible values"

        ''' <summary>
        ''' The _ list style position
        ''' </summary>
        ReadOnly _listStylePosition As New List(Of KeyValuePair(Of String, String))()
#End Region

        ''' <summary>
        ''' Initializes a new instance of the <see cref="ucListPosition"/> class.
        ''' </summary>
        ''' <param name="dict">The dict.</param>
        Public Sub New(dict As Dictionary(Of String, String))
            _dict = dict

            '#Region "Initialize presets"
            _listStylePosition.Add(New KeyValuePair(Of String, String)("<Not Set>", ""))
            _listStylePosition.Add(New KeyValuePair(Of String, String)("Outside (text is indented in)", "outside"))
            _listStylePosition.Add(New KeyValuePair(Of String, String)("Inside (text is not indented)", "inside"))
            '#End Region

            InitializeComponent()
        End Sub

        ''' <summary>
        ''' Flushes the content of the user control back to the dictionary
        ''' </summary>
        Public Sub FlushContent() Implements IEditorStylePage.FlushContent
            _dict.Remove("list-style-position")
            _dict("list-style-position") = DirectCast(cbBulletPosition.SelectedValue, String)
        End Sub

        ''' <summary>
        ''' Handles the Load event of the ucLists control.
        ''' </summary>
        ''' <param name="sender">The source of the event.</param>
        ''' <param name="e">The <see cref="EventArgs"/> instance containing the event data.</param>
        Private Sub ucLists_Load(sender As Object, e As EventArgs)
            '#Region "set data sources"

            cbBulletPosition.DataSource = _listStylePosition
            cbBulletPosition.DisplayMember = "Key"
            cbBulletPosition.ValueMember = "Value"

            '#End Region


            Dim value As String

            '#Region "parse"

            If _dict.TryGetValue("list-style-position", value) Then
                Dim i As Integer = 0, n As Integer = _listStylePosition.Count
                While i < n
                    If String.Equals(value, _listStylePosition(i).Value, StringComparison.InvariantCultureIgnoreCase) Then
                        cbBulletPosition.SelectedIndex = i
                        Exit While
                    End If
                    i += 1
                End While
            End If

            '#End Region
        End Sub

    End Class
End Namespace