﻿using System.Collections.Generic;
using System.Windows.Forms;
using SpiceLogic.HtmlEditorControl.Domain.DesignTime;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private readonly List<DictionaryFileInfo> _dictionaries = new List<DictionaryFileInfo>();

        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Handles the Load event of the Form1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void Form1_Load(object sender, System.EventArgs e)
        {
            winFormHtmlEditor1.SpellCheckOptions.CurlyUnderlineImageFilePath = Application.StartupPath + "\\curly_underline_for_spell_checker.gif";

            _dictionaries.Add(new DictionaryFileInfo(@"dic\en_US.aff", @"dic\en_US.dic", @"dic\Custom_en_US.dic"));
            _dictionaries.Add(new DictionaryFileInfo(@"dic\fr_FR.aff", @"dic\fr_FR.dic", @"dic\Custom_fr_FR.dic"));

            languageComboBox.SelectedIndex = 0;
        }

        /// <summary>
        /// Handles the 1 event of the languageComboBox_SelectedIndexChanged control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.EventArgs"/> instance containing the event data.</param>
        private void languageComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            winFormHtmlEditor1.SpellCheckOptions.DictionaryFile = _dictionaries[languageComboBox.SelectedIndex];
        }
    }
}
